CIP Core: Package Decision Process
==================================

This document defines the process how we can propose Debian packages
as the target of CIP's long-term maintenance, how CIP reviews
the proposals and makes a decision (accepts or rejects), and
how to manage the accepted Debian packages.

Definitions of Terms
====================

* _CIP member company_
    * The companies who has already been the CIP member:
      https://www.cip-project.org/members
* _CIP Core WG company_
    * The companies who declare to join CIP Core WG
    * Subset of the "CIP member company"
* _CIP maintained package list_
    * Debian source package list that CIP will maintain after
      Debian LTS becomes EOL
    * Decided & updated by the "package decision process"
* _Package decision process_
    * The process to determine the "CIP maintained package list"
    * Defined in this document

Workflow
========

* Phase 1: Package proposal
* Phase 2: Proposal review
* Phase 3: Discussion
* Phase 4: TSC Approval
* Phase 5: Package registration

![pdp_workflow](./pdp_workflow.jpg)

Phase 1: Package Proposal
=========================

Procedure
---------

* A CIP member company creates the package proposal which includes
  the "required information" below using the "proposal generator"
* The CIP member company sends the package proposal to the CIP Core WG
* When a non CIP member wants to create the package proposal,
  find CIP member companies who are interested in the proposal
  and ask them sending the proposal instead

Restrictions
------------

* Any CIP member companies can make a proposal
* Non CIP members cannot send any proposals to the CIP Core WG directly,
  but CIP member companies who are interested in the proposals can act for them
* No time restriction; CIP member companies can make a proposal anytime

Required Information
--------------------

* Proposer name
* Proposed date
* Revision of the package decision process
* Debian source package name
    * e.g. glibc, openssh, gcc8
* Debian binary package name (list)
    * e.g. libc6, libssl1.1, libgcc1
    * To specify the range of maintained functions
* Debian version
    * e.g. Debian 10 buster
* Reason
* Run-time dependencies in Debian
    * Automatically generated by the "proposal generator"
    * Dependencies resolved based on:
      `apt-cache -i depends <Debian binary package name list above>`
    * If there are multiple options (OR, virtual packages) in a dependency,
      the script show the options and ask users to select one
    * All run-time dependencies must be satisfied by the packages
      in the CIP maintained package list or proposed in the same proposal
* Whether used in the target rootfs (TRUE/FALSE)
  to specify the range of supported usages
* Maintenance cost estimation
  (Required only if the package is used in the target rootfs)
    * The List of "security criteria" matching to the binary packages
        * See the "Security Criteria" section
    * The number of CVEs found so far
        * Use the number of CVEs in Debian security tracker
        * Automatically checked by the "proposal generator"

Proposal Generator
------------------

* Repository: https://gitlab.com/cip-project/cip-core/cip-pkglist

* `generate-proposal.py`
    * The main script to generate package proposals

* `get_pkg_depends.py`
    * Back-end script to get run-time dependencies of a Debian package
    * Used by `generate-proposal.py`
* `count_cve.py`
    * Back-end script to get the number of CVEs found in a Debian package
    * Used by `generate-proposal.py`
* `check_deps.py`
    * Back-end script to check if all run-time dependencies in a proposal
      are satisfied by the proposal itself and `pkginfo_CODENAME.yml`
    * Used by `generate-proposal.py` and `pkginfo.py`

Security Criteria
-----------------

Here is the list of software categories, which should be
maintained carefully from the security point of view.
The [Debian package tags](https://packages.debian.org/about/debtags)
are used to categorize these packages.

* Network software
    * Bugs that can be exploited remotely are the most dangerous
    * Tag: `network::`
* Security software
    * LSM modules, encryption, and authorization are the foundation
      of a security-hardened system
    * Tag: `security::`
* Language runtimes/compilers
    * They are common to many applications
    * Tag: `devel::lang`, `devel::compiler`

Phase 2: Proposal Review
========================

Procedure
---------

* All CIP Core WG companies except the proposer (= Reviewers) review
  the proposal in the "phase 1", then show their opinion
  (agree or disagree) about the proposed package
* If reviewers disagree the proposed package, they have to show
  the clear reasons
* If all reviewers say "agree", the proposal is accepted and
  go to the "phase 4"
* If one or more reviewers say "disagree", go to the "phase 3"

Restrictions
------------

* Only CIP Core WG companies can join the review

Due Date
--------

* Reviewers need to show their opinion for each proposed package in two weeks
  from the "Proposed date", as a default timeline
* The responsibility to set a deadline and chase for reviews lies with
  the proposal submitter
* If more than 50% of reviewers don't reply by the due date,
  the proposer should extend the due date to get replies from reviewers

Phase 3: Discussion
===================

Procedure
---------

* The proposer and the reviewers who disagreed the proposal need to exchange
  their opinions carefully and deeply
* In this discussion, the proposer and all reviewers can change their opinion
  if needed
* If greater than 50% CIP Core WG companies can agree, the proposal is
  accepted and go to the "phase 4", otherwise rejected
* On the due date, if less than 50% CIP Core WG companies agree,
  the proposal is rejected
    * NOTE: The rejected package can be re-proposed later (See "Other Rules")

Due Date
--------

* The proposer and reviewers can discuss for two weeks from
  when the discussion starts

Phase 4: Approval
=================

Procedure
---------

* CIP Core WG shares the package information accepted in the "phase 2" or
  "phase 3" with TSC, appending the "Additional information" below
* CIP Core WG asks TSC to approve of registering the package to
  the CIP maintained package list
* If the proposal is approved by TSC, go to the "phase 5"
* If the proposal is rejected by TSC, the package is not registered
    * CIP Core WG considers re-proposing the package applying feedback from TSC

Additional Information
----------------------

* The URL(s) to the ML thread(s) about the "Phase 3" discussions (if exists)

Due Date
--------

* None

Phase 5: Package Registration
=============================

Procedure
---------

* CIP Core WG registers the package information approved in the "phase 4"
  to the CIP maintained package list

Package Register
----------------

* Repository: https://gitlab.com/cip-project/cip-core/cip-pkglist

* `pkginfo.py`
    * The script to register packages to the CIP maintained package list
* `pkginfo_CODENAME.yml`
    * The CIP maintained package list for each Debian codename (e.g. buster)

Other Rules
===========

* Any CIP members can ask CIP Core WG the update of this document (rules)
* Any CIP Core WG companies can request extending each due date
  with clear reasons
* Any packages can be re-proposed with updates even if
  they were already accepted or rejected previously
* All phases (proposal, review, discussion, registration) should be done
  through the `cip-dev@lists.cip-project.org` mailing list
